Index: sys/geom/eli/g_eli_key.c
===================================================================
--- sys/geom/eli/g_eli_key.c	(revision 277169)
+++ sys/geom/eli/g_eli_key.c	(working copy)
@@ -158,6 +158,9 @@
     unsigned char *mkey)
 {
 	unsigned char enckey[SHA512_MDLEN];	/* Key for encryption. */
+#if !defined(__NO_STRICT_ALIGNMENT)
+	unsigned char tmpmkey[G_ELI_MKEYLEN];
+#endif
 	int error;
 
 	/*
@@ -164,7 +167,13 @@
 	 * To calculate HMAC, the whole key (G_ELI_USERKEYLEN bytes long) will
 	 * be used.
 	 */
+#if !defined(__NO_STRICT_ALIGNMENT)
+	/* copy mkey to tmpmkey (sp aligned) */
+	bcopy(mkey, tmpmkey, G_ELI_MKEYLEN);
+	g_eli_mkey_hmac(tmpmkey, key);
+#else
 	g_eli_mkey_hmac(mkey, key);
+#endif
 	/*
 	 * The key for encryption is: enckey = HMAC_SHA512(Derived-Key, 1)
 	 */
@@ -173,7 +182,14 @@
 	 * Encrypt the Master-Key and HMAC() result with the given key (this
 	 * time only 'keylen' bits from the key are used).
 	 */
+#if !defined(__NO_STRICT_ALIGNMENT)
+	/* encrypt and back to mkey */
+	error = g_eli_crypto_encrypt(algo, tmpmkey, G_ELI_MKEYLEN, enckey, keylen);
+	bcopy(tmpmkey, mkey, G_ELI_MKEYLEN);
+	bzero(tmpmkey, G_ELI_MKEYLEN);
+#else
 	error = g_eli_crypto_encrypt(algo, mkey, G_ELI_MKEYLEN, enckey, keylen);
+#endif
 
 	bzero(enckey, sizeof(enckey));
 
